from __future__ import annotations

from typing import Tuple

from core.constants import CellValue
from ..Command import Command, WORLD_PRIORITY, WORLD_MAX_WIDTH


class SetLayerValueCommand(Command):

    def __init__(self, coords: Tuple[int, int], value: CellValue, fill: bool = False):
        self._coords = coords
        self._value = value
        self._fill = fill

    def priority(self) -> int:
        return WORLD_PRIORITY + self._coords[0] + self._coords[1] * WORLD_MAX_WIDTH


