import inspect
from itertools import islice
from typing import Union, Optional

import pygame
from pygame import Surface

from .Component import Component


class CacheComponent(Component):

    def __init__(self, component: Component):
        super().__init__(component.theme)
        self.__component = component
        self.__surface: Optional[Surface] = None

    @property
    def component(self) -> Component:
        return self.__component

    # Component

    def dispose(self):
        self.__component.dispose()

    def render(self, surface: Surface):
        if self.__surface is None or self.__component._needRefresh:
            self.__surface = Surface(surface.get_size(), flags=pygame.SRCALPHA)
            self.__component.render(self.__surface)
        surface.blit(self.__surface, (0, 0))


