from abc import abstractmethod
from typing import Tuple

from pygame import Surface

from core import Listenable
from ..Mouse import Mouse
from ..theme.Theme import Theme


class Component:
    def __init__(self, theme: Theme):
        super().__init__()
        self.__theme = theme
        self._needRefresh = True

    @property
    def theme(self) -> Theme:
        return self.__theme

    # Component

    def dispose(self):
        pass

    @abstractmethod
    def render(self, surface: Surface):
        raise NotImplementedError()


